HC = require 'HardonCollider'
require "coup.coup"
World = require "world"

function love.load()
  G = {}
  G.music = love.audio.newSource("data/music.mp3", "stream")
  G.music:setLooping(true)
  G.music:play()

  G.font = love.graphics.newFont("data/font.ttf", 9)
  love.graphics.setFont(G.font)
  G.screenSize = {320, 200}
  G.loadImage = coup.cache(love.graphics.newImage)
  G.animRepo  = coup.sprite.AnimationRepository()

  coup.spriteloader.loadAll("data/sprites", G.animRepo, G.loadImage) 


  G.sounds = {}
  local sounds = { 
    "jump",
    "coin",
    "burn",
    "land",
    "respawn",
    "stab",
    "fireball",
    "checkpoint",
    "fbdie",
    "orb",
    "fall",
    "blip"
  }
  
  for i, s in pairs(sounds) do
    G.sounds[s] = love.audio.newSource("data/sounds/" .. s .. ".wav", "static")
  end 



  G.canvas = love.graphics.newCanvas(G.screenSize[1], G.screenSize[2])
  G.canvas:setFilter('nearest', 'nearest')
  G.world = World()
  G.world:update(0)
end


function love.update(dt)
  G.world:update(dt)
end


function love.draw()
  love.graphics.setCanvas(G.canvas)
  G.world:draw()
  love.graphics.setCanvas()
  local w, h = love.graphics.getDimensions()
  local sx = w / G.screenSize[1]
  local sy = h / G.screenSize[2]
  love.graphics.draw(G.canvas, 0, 0, 0, sx, sy)
end
