PlayerController = coup.class({})

function PlayerController:new(player)
  self.player = player
end


function PlayerController:readInput()
  local actions = {
    fire =  {state = false, key = "x",     button = "x"},
    jump =  {state = false, key = "c",     button = "a"},
    left =  {state = false, key = "left",  button = "dpleft"},
    right = {state = false, key = "right", button = "dpright"},
  }

  local events = {}

  local joysticks = love.joystick.getJoysticks()
  for k, a in pairs(actions) do
    for i, joystick in ipairs(joysticks) do
      events[k] = events[k] or joystick:isGamepadDown(a.button)
    end

    events[k] = events[k] or love.keyboard.isDown(a.key)
  end

  return events
end


function PlayerController:update()
  local events = self:readInput()

  local input = self.player:getComponent("Input")
  for i, e in pairs(events) do
    input[i] = e
  end

end
