Rain = coup.class({})

function Rain:new()
  self.drops = {}
  for i = 1, 50 do
    self.drops[i] = {}
    Rain.spawn(self.drops[i])
    self.drops[i].x = math.random(G.screenSize[1])
    self.drops[i].y = math.random(G.screenSize[2])
  end

end


function Rain.spawn(r)
  local d = math.random(G.screenSize[1] + G.screenSize[2])
  if d > G.screenSize[1] then
    r.y = d - G.screenSize[1]
    r.x = G.screenSize[1]
  else
    r.x = d
    r.y = 0
  end

  r.dx = -math.random(600, 700)
  r.dy = math.random(400, 500)
  r.alpha = math.random(64, 128)

end

local dxScale = 0.02

function Rain:update(dt)
  for i, d in ipairs(self.drops) do
    d.x = d.x + dt * d.dx
    d.y = d.y + dt * d.dy

    if d.x < d.dx * dxScale or d.y > G.screenSize[2] + d.dy * dxScale  then
      Rain.spawn(d)
    end
  end

end


function Rain:render()
  love.graphics.setLineStyle("rough")
  love.graphics.setLineWidth(0.75)

  for i, r in ipairs(self.drops) do
    --love.graphics.setColor(255,255,255, r.alpha)
    love.graphics.setColor(r.alpha, r.alpha, r.alpha, 192)
    love.graphics.line(math.floor(r.x), math.floor(r.y), math.floor(r.x - dxScale * r.dx), (r.y - dxScale * r.dy))
  end
  love.graphics.setColor(255,255,255,255)
end
